Public Class Form1
    Private WithEvents cTboxE As clsTextboxError

    Private Sub Form1_Load(ByVal sender As System.Object, _
                           ByVal e As System.EventArgs) Handles MyBase.Load

        cTboxE = New clsTextboxError(Me, True)

        TextBox1.MaxLength = 6
        TextBox2.MaxLength = 12
        TextBox3.MaxLength = 12

        TextBox5.MaxLength = 10
        TextBox6.MaxLength = 5

        Label1.Text = "numerisch, n,2"
        Label2.Text = "aut. Upper"
        Label3.Text = "No Space"
        Label4.Text = "Only abcdefg"
        Label5.Text = "Datum"
        Label6.Text = "Uhrzeit"
    End Sub

    ''' <summary>
    '''   Eingabeprfung bei KeyPress
    ''' </summary>
    Private Sub cTboxE_KeyPress(ByVal sender As Object, _
               ByRef e As System.Windows.Forms.KeyPressEventArgs) _
               Handles cTboxE.KeyPress

        Dim Tbox As TextBox = DirectCast(sender, TextBox)
        Select Case Tbox.Name
            Case "TextBox1"
                cTboxE.CheckNumericKeyPress(sender, e, 2)
            Case "TextBox2"
                cTboxE.CharToUpper(sender, e)
            Case "TextBox3"
                cTboxE.CharNoSpace(sender, e)
            Case "TextBox4"
                Dim s As String = "abcdefg"
                cTboxE.ThisCharsAllowedOnly(sender, e, s)
            Case "TextBox5"
                cTboxE.CheckDateKeyPress(sender, e)
            Case "TextBox6"
                cTboxE.CheckTimeKeyPress(sender, e)
            Case Else
                cTboxE.SendKeyTabOnEnter(sender, e)
        End Select
    End Sub

    ''' <summary>
    ''' Formatierung bei Verlassen der Textbox
    ''' </summary>
    Private Sub cTboxE_Validated(ByVal sender As Object, _
                ByVal e As System.EventArgs) Handles cTboxE.Validated

        Dim Tbox As TextBox = DirectCast(sender, TextBox)
        Select Case Tbox.Name
            Case "TextBox1"
                If Not String.IsNullOrEmpty(Tbox.Text) Then
                    Dim d As Decimal = Decimal.Parse(Tbox.Text)
                    If d <> 0 Then
                        Tbox.Text = d.ToString("0.00")
                    End If
                End If
        End Select

    End Sub

    ''' <summary>
    ''' Logische Prfung vor Verlassen der Textbox
    ''' </summary>
    Private Sub cTboxE_Validating(ByVal sender As Object, _
                ByVal e As System.ComponentModel.CancelEventArgs) _
                Handles cTboxE.Validating

        Dim Tbox As TextBox = DirectCast(sender, TextBox)
        Select Case Tbox.Name
            Case "TextBox5"
                cTboxE.DateValidating(sender, e)
            Case "TextBox6"
                cTboxE.TimeValidating(sender, e, "HH:mm")
        End Select
    End Sub

    Private Sub TBox_KeyDown(ByVal sender As Object, _
                ByVal e As System.Windows.Forms.KeyEventArgs)

        ' nur zur Demonstration fr zustzliche AddHandler
        '   Debug.Print(sender.Name)
    End Sub
End Class
